/* License. */
/*  */
/* tri_rend.h */
/*  */
/* This file provides a triangle sub-divider. */



#ifndef TRI_REND_H

# define TRI_REND_H



# if !defined( USE_FLT ) && !defined( USE_DBL ) && !defined( USE_LDBL )
#  error "tri_rend.h requires the macro USE_FLT, USE_DBL, or USE_LDBL to be defined."
# else



#  include "SDL_surface.h"

	/* Probably common_macros.h is already indirectly included, but... */
#  include "common_macros.h"
#  include "geo_code.h"

#  define TRIOVERAREA CONCAT( NAMESPACE, triangle_overlap_getarea )
#  define SRC_TERM CONCAT( NAMESPACE, src_terminal )
#  define COORD_TRANS CONCAT( NAMESPACE, coordinate_translator )
#  define TRI_REND CONCAT( NAMESPACE, tri_rend )

#  define STD_VERIFARG CONCAT( NAMESPACE, std_verifarg )

/* The names for the triangle sub-dividers are defined further down, where */
/*  their actual prototypes are defined. */



int TRIOVERAREA( TRI *a, TRI *b );



typedef struct tri_info
{
	FLT_TYPE area_accumulator;
	FLT_TYPE r_accumulator, g_accumulator, b_accumulator, a_accumulator;
	
	FLT_TYPE dest_area;
	FLT_TYPE dest_r, dest_g, dest_b, dest_a;
	
	TRI *src_tri, *dest_tri;
	
	SDL_Surface *src, *dest;
	Uint32 src_fill;
	
} tri_info;



typedef tri_info* divfuncdata;
#  define DIVFUNCDATA divfuncdata



int SRC_TERM( DIVFUNCDATA fc,  TRI *a, TRI *b );
int COORD_TRANS( DIVFUNCDATA fc,  TRI *a, TRI *b );
int TRI_REND( DIVFUNCDATA info, TRI *dest, TRI *src );
int STD_VERIFARG( DIVFUNCDATA ti, TRI *a, TRI *b );



/* Create the function prototypes for the triangle sub-dividers. These don't */
/*  define any preprocessor macros, so no end_divfunc.h is needed (or */
/*  provided). */

#  define DIVFUNC CONCAT( NAMESPACE, get_trianglearea_recursive )
#  define TERMFUNC area_wrapper
#   include "divfunc.h"
#  undef TERMFUNC
#  undef DIVFUNC

#  define DIVFUNC CONCAT( NAMESPACE, src_fragmenter )
#  define TERMFUNC src_terminal
#   include "divfunc.h"
#  undef TERMFUNC
#  undef DIVFUNC

#  define DIVFUNC CONCAT( NAMESPACE, dest_fragmenter )
#  define TERMFUNC coordinate_translator
#   include "divfunc.h"
#  undef TERMFUNC
#  undef DIVFUNC


# endif

#endif
/* End tri_rend.h */
